from StringIO import StringIO

from Products.CMFCore.utils import getToolByName
from Products.PluggableAuthService.interfaces.plugins import IAuthenticationPlugin
from Products.CheckIPPlugin.plugin import CheckIPPlugin

ID = 'check_ip'

def install(portal):
    out = StringIO()
    acl_users = getToolByName(portal, 'acl_users')
    # check if there is not yet an object called 'check_ip' in acl_users
    if not ID in acl_users.objectIds():
        # add a plugin
        factories = acl_users.manage_addProduct['CheckIPPlugin']
        factories.manage_addCheckIPPlugin(ID, title='Check IP Plugin')
        print >> out, "Plugin installed."
        # and activate it
        acl_users.plugins.activatePlugin(IAuthenticationPlugin, ID)
        print >> out, "Plugin activated."
    else:
        print >> out, "Plugin called 'check_ip' already installed."
    return out.getvalue()

def uninstall(portal):
    out = StringIO()
    acl_users = getToolByName(portal, 'acl_users')
    if ID in acl_users.objectIds() and isinstance(getattr(acl_users, ID), CheckIPPlugin):
        acl_users.manage_delObjects(ids=[ID]) 
        print >> out, "Plugin removed."
    else:
        print >> out, "There is no plugin called 'check_ip'."
    return out.getvalue()
